#include "main.hpp"
#include "Game.hpp"
#include "TextGame.hpp"
#include "TextGameReader.hpp"
#include "ManyRunsLogicInfo.hpp"
#include <stack>
#include <iostream>
#include <fstream>


typedef struct {
  int tid ; // tower
  int x ;   // coord x
  int y  ;  // coord y
  int operation ; // 4 add , 0 - only store, mark ;
  int linkx  ; // links x coord
  int linky  ; // links y coord
}  _tower_ ;


void free_memory () ;
void init (TextGame *game) ;
int compute_demage_mob ( TextGame *game , int w )  ;
int permutation ( int , int ) ;
int build_decision ( int k  , TextGame *game , int w) ;
int build_decision_finish ( int save_k, TextGame *game , int w) ;
int fill_mirror ( TextGame *game ) ;
int search_tower ( int tid , std::vector<_tower_> vv, TextGame *game) ;
int print_instruction (std::stack<_tower_> ss , std::vector <_tower_> vv, TextGame *game) ;
int index[70] , save_index[70] ;
int mirror[64][64] ;
int tidindex[64] ;

int selltowerstore[1024][2] ;
int countselltower ;
int selltower ( int , int ) ;
int choice_sell ( int w , TextGame *game ) ;

int print_mirror ( TextGame *game ) ;


int **matrix_tower_wave ;
int *number_mob_lives_wave ;
const char INPUT_FILE_NAME[] = "towerdef.in";
const char OUTPUT_FILE_NAME[] = "towerdef.out";
int in_towers , in_waves ;
int MinPrice ;
int temp_stick  ;
int64 temp_money  ;
int X , Y ; // coord tower

std::ofstream fout ;

#define OUT   fout
//#define OUT   std::cout

void smarterTest(){

    TextGame *game = TextGameReader::read( INPUT_FILE_NAME );
    init ( game ) ;
    ManyRunsLogicInfo *logicInfo = new ManyRunsLogicInfo;
    int  w, flag ;
    int  t, k,  save_k , l, MaxStick  ;
    int demage_mob ;
    l = in_towers -1 ;

    for(  w = 0 ; w < (int) game->all_waves.size() ; w++ ){
    // check turret
      demage_mob =  compute_demage_mob ( game ,  w )  ;
      if ( demage_mob  >= number_mob_lives_wave[w] ) {
        // nothing to do , write 0 and continue
        OUT << "0 " << std::endl ;
        countselltower = 0 ;
        int len = game->all_waves[w].size();
        std::vector< RunningMob* > mobs;
        for( int i = 0   ; i < len ; i++ ){
             int type = game->all_waves[w][i].first;
             int count = game->all_waves[w][i].second;
             for( int j = 0 ; j < count ; j++ )
                mobs.push_back( new RunningMob( game->all_mobs[type] ) );
        }

        game->go( waveRunLogicManyInRangeCalls ,
                  mobs ,
                  defaultMobInRangeForManyCalls ,
                  defaultMobFellDead ,
                  defaultMobReachedTheEnd ,
                  logicInfo
                );

       if ( game->lives > 0 )
           game->money = game->money + game->money_on_completion[w];
         // std::cout << "game->money " <<  game->money  << std::endl ;
        continue ; // !!!!
      }   // if end nothing
      //  find decision
      demage_mob = number_mob_lives_wave[w] - demage_mob ;
      //std::cout << " demage_mob " << demage_mob << " wave " << w << std::endl ;
      // find tourrets
      t =  game->money / MinPrice ;
      //if ( t == 0 ) {
      //  std::cout << "Sell towers no money for this wave" << std::endl ;
        // TO DO continue ; // !!!!
     // }

      t = ( game->totalTurretsBuild() + t < 64 ) ? t : (64 - game->totalTurretsBuild() ) ;
      if ( t > 8 ) t = 8 ;
      MaxStick = 0 ; flag = 0 ;
      for ( k =1 ; k < t ; ++k  ) {
        for ( int i = 0 ; i < k ; i++) index[i] = -1 ;
        while ( !permutation ( k , l)) {
          temp_stick = 0 ;  temp_money = 0 ;
          for ( int i = 0 ; i < k ; i++) {
            //std::cout << index[i] << " " ;
            temp_stick=temp_stick+matrix_tower_wave[index[i]][w]+number_mob_lives_wave[w] ;
            temp_money=temp_money+game->all_turrets[index[i]]->buy_price ;
         }
          //std::cout << std::endl ;
         if ( MaxStick < temp_stick ) {
           if ( temp_money > game->money ) continue ;
              if ( build_decision ( k , game , w )  ) continue ;
              if ( MaxStick < temp_stick ) {
                MaxStick = temp_stick ;
                //save decision ;
                save_k = k ;
                for ( int p=0; p<k ; p++) save_index[p] = index[p];
              }
              if ( MaxStick >= demage_mob ) {
                  flag = 1 ;
                  break ;
              }
            }
         }  // end work block
        if ( flag ) break ;
     }  // end for , numbers index
     if  ( MaxStick > 0   ) {
        // std::cout << "MaxStick " << MaxStick << std::endl ;
         build_decision_finish ( save_k , game , w ) ;
         // std::cout << "----" << std::endl ;
         // fill_mirror(game) ;
         // print_mirror(game) ;
         // std::cout << "----" << std::endl ;

     }
     else {
         fill_mirror ( game )  ;
         // sell towers
         //std::cout << "w " << w << " sell " << std::endl ;
         if ( !choice_sell ( w , game ) ) {
         --w ;
         //std::cout << "run choice sell w " << w   << std::endl ;
         continue ;
         }



         // no decision , write 0
         if ( countselltower > 0  ) {
             OUT << countselltower  << std::endl ;
             for ( int p=0; p<countselltower ; p++) {
                    OUT << "5 " <<  selltowerstore[p][0] << " " ;
                    OUT <<  selltowerstore[p][1] << " " << std::endl ;
             }
             countselltower = 0 ;

         }
         else {
           OUT << "0 "  << std::endl ;
           countselltower = 0 ;
         }

     }

      // check deccision

      int len = game->all_waves[w].size();
      std::vector< RunningMob* > mobs;
      for( int i = 0   ; i < len ; i++ ){
            int type = game->all_waves[w][i].first;
            int count = game->all_waves[w][i].second;
            for( int j = 0 ; j < count ; j++ )
                mobs.push_back( new RunningMob( game->all_mobs[type] ) );
        }

        game->go( waveRunLogicManyInRangeCalls ,
                  mobs ,
                  defaultMobInRangeForManyCalls ,
                  defaultMobFellDead ,
                  defaultMobReachedTheEnd ,
                  logicInfo
                );

       if ( game->lives > 0 )
           game->money = game->money + game->money_on_completion[w];

         // std::cout << "game->lives " << game->lives << ",game->money " << game->money << std::endl ;

   } // end w

    delete logicInfo ;
    return ;

}



int main(){
    smarterTest();
    free_memory() ;
    return 0;
}

void free_memory () {
 for (int   a = 0 ; a < in_towers ; a++ )
       delete [] matrix_tower_wave[a] ;
 delete [] matrix_tower_wave ;
 delete [] number_mob_lives_wave ;
 fout.close() ;
 return ;
}

void init (TextGame *game) {
    int live_mob , x , y ,tid , len ;
    int a , b , c ,  flag;

    int64 saveMoney ;
    int saveLive ;


    ManyRunsLogicInfo *logicInfo = new ManyRunsLogicInfo;
    std::vector< FieldCellCoord > upgrades;


    in_towers = (int) game->all_turrets.size() ;
    in_waves  = (int) game->all_waves.size();

    saveMoney =  game->money ;
    saveLive =  game->lives ;
    MinPrice = 2147483647  ;
    for ( int i =0 ; i < in_towers ; ++i )
       if ( MinPrice > game->all_turrets[i]->buy_price )
         MinPrice = game->all_turrets[i]->buy_price ;
    for ( int i=0 ; i < 64 ; ++i) tidindex[i] = -1 ;


    matrix_tower_wave = new int*[in_towers]  ;
    number_mob_lives_wave = new int [in_waves];
    for ( a = 0 ; a < in_towers ; a++)
       matrix_tower_wave[a] = new int [in_waves] ;


    for (  tid = 0 ; tid < (int) game->all_turrets.size() ; ++tid ) {
       len = (int)game->field->path.size() ;
       flag = 0 ;
       for ( a = 0 ; a <  game->field->rows; a++) {
        if ( flag == 1 ) break ;  // there is field
        for ( b = 0 ; b <  game->field->cols; b++) {
            if ( game->field->isFree ( a, b )) {
               for(  c = 0 ; c < len ; c++ ){
                    int pathX = game->field->path[c].x;
                    int pathY = game->field->path[c].y;
                    if( abs(pathX - a) <= game->all_turrets[tid]->range and abs(pathY - b) <= game->all_turrets[tid]->range ){
                        flag = 1 ;
                        x = a ; y = b ;
                        break ;
                    }
                }
             }

        }
       }

       if( game->buyTurret( tid  , x ,y , upgrades ) < 0 ){
        printf ( "error bay turrent %d \n" , tid ) ;
        return  ;
       }


    for( int w = 0 ; w < (int) game->all_waves.size() ; w++ ){

        int len = game->all_waves[w].size();

        std::vector< RunningMob* > mobs;
        live_mob = 0 ; game->lives = 0 ;
        for( int i = 0   ; i < len ; i++ ){
            int type = game->all_waves[w][i].first;
            int count = game->all_waves[w][i].second;
            live_mob += count ;
            for( int j = 0 ; j < count ; j++ )
                mobs.push_back( new RunningMob( game->all_mobs[type] ) );
        }

        game->go( waveRunLogicManyInRangeCalls ,
                  mobs ,
                  defaultMobInRangeForManyCalls ,
                  defaultMobFellDead ,
                  defaultMobReachedTheEnd ,
                  logicInfo
                );

 //       printf  ( "tower=%d,wave=%d,game->lives=%d,live_mob_weves=%d\n",
 //                tid,w,game->lives,live_mob) ;
        matrix_tower_wave[tid][w] = game->lives ;
        number_mob_lives_wave[w] = live_mob ;

      }
      if( !game->sellTurret( x ,  y ) )
         printf ( "error sell x=%d,  y=%d\n" , x , y ) ;


//      std::cout << " game->totalTurretsBuild() "  <<  game->totalTurretsBuild() << std::endl;
//      std::cout << " X "  <<  x  << " Y " << y << std::endl;
//      std::cout << " getTurretId ( x, y )  "  << game->field->getTurretId(x,y) << std::endl;
    }

    game->money = saveMoney ;
    game->lives  = saveLive;
    delete logicInfo ;

/*
    for ( a = 0 ; a < in_towers ; a++ ) {
        b = game->upgrade_graph[a].size() ;
        std::cout << "tower " << a << " relate " << b  ;
        std::cout << " bay money " << game->all_turrets[a]->buy_price  ;
        std::cout << " sell money " << game->all_turrets[a]->sell_price << std::endl;
        if ( b > 0 )  {
           while ( --b >= 0 )
                std::cout << game->upgrade_graph[a][b] << " ";
            std::cout << std::endl ;

        }
    }

*/

    fout.open(OUTPUT_FILE_NAME,std::ios::out) ;
    if ( !fout.is_open()) {
        std::cout << "cant create " <<  OUTPUT_FILE_NAME << std::endl ;
    }



}

int compute_demage_mob ( TextGame *game , int w )  {
  int  demage_mob , a , b, tid ;
  demage_mob = 0 ;
  for ( a = 0 ; a <  game->field->rows; a++)
      for ( b = 0 ; b <  game->field->cols; b++)
        if ( game->field->isTurret ( a, b ) == 1 ) {
             tid = game->field->getTurretId(a,b) ;
             demage_mob = demage_mob + matrix_tower_wave[tidindex[tid]][w] + number_mob_lives_wave[w] ;
        }
  return demage_mob ;
}

 int permutation ( int k , int l )
 {  // begin block k - permutacions
   static int j ;
   int i , fg;

   fg = 0 ;
   for ( i = 0 ; i < k ; i++)
     if ( index[i] == -1 ) {
       fg = 1 ;
       index[i] = 0 ;
     }

    if ( fg == 1 ) {
     j = k - 1 ;
     index[j] = -1 ;
    }

     while ( 1 ) {
       if( index[j] < l ) {
         ++index[j] ;
         return 0 ;
       }
       else {
         if ( --j  >= 0  ) {
           if (index[j] < l ) {
              ++index[j] ;
              for ( i = j+1 ; i < k ; i++ ) index[i] = 0 ;
              j = k - 1 ;
              index[j] = -1 ;
              continue ;
           }
           else continue ;

       }
       else break ;
     }
  /*   if ( k > 1 ) {
       fg = 0 ;
       for ( i = 0 ; i < k -1  ; i++ )
         if ( index[i] > index[i+1]) {
           fg = 1 ;
           break ;
         }
       if ( fg )  continue ;
   }
  */
   return 0 ;
 }  // end while ( 1 )
   return 1;
}


int fill_mirror ( TextGame *game ) {
  int i , j  ;

  // -1 = path , -2 = free , -3 block , zero or positive number tower ID
  for ( i = 0 ; i < game->field->rows ; i++ )
    for ( j = 0 ; j < game->field->cols;j++ ) {
        mirror[i][j] =  -3  ;  // block
        if ( game->field->isTurret ( i,j )) {
          mirror[i][j] =  tidindex[game->field->getTurretId(i,j)] ;
          if ( mirror[i][j] == -1 ) {
              printf ( "error tower mnogo zle %d  %d \n" , i , j);
          }
        }
        if ( game->field->isFree ( i,j ))
          mirror[i][j] =  -2  ;
        if ( game->field->isPath ( i,j ))
          mirror[i][j] =  -1  ;
   }

   return 0 ;

}

int coordTower ( int tid , TextGame *game  ) {
 int num_tower = 0 ;
 for ( int a = 0 ; a < game->field->rows ; a++ )
  for ( int b = 0 ; b < game->field->cols;b++ )
          if ( mirror[a][b] >= 0  ) ++num_tower ;
  if ( num_tower >= 64 ) return 1 ;

 int  len = (int)game->field->path.size() ;
   for ( int a = 0 ; a < game->field->rows ; a++ )
    for ( int b = 0 ; b < game->field->cols;b++ ) {
        if ( mirror[a][b] == -2  ) {
          if ( game->all_turrets[tid]->type == 2 ) {
             for( int  c = 0 ; c < len ; c++ ){
               int pathX = game->field->path[c].x;
               int pathY = game->field->path[c].y;
               if( abs(pathX - a) <= game->all_turrets[tid]->range and
                   abs(pathY - b) <= game->all_turrets[tid]->range ){
                    X = a ; Y = b ;
                    mirror[a][b] = tid ;
                    return 0 ;
               }
             }
          }
          else {
            X = a ; Y = b ;
            mirror[a][b] = tid ;
            return 0 ;
        }
      }
    }
    X=-1 ; Y=-1 ;
    return 1 ;
}


int build_decision ( int k  , TextGame *game , int w ) {
 std::stack<_tower_> build ;
 std::vector<_tower_> store ;
 _tower_ temp  ;
 int i ,  ind = 0  ;

  // -1 = path , -2 = free , -3 block , zero or positive number tower ID
 fill_mirror ( game ) ;
 temp_stick = 0 ;
 temp_money = 0 ;

  for (i=0 ; i < k ; i++  ) {
  if ( coordTower ( index[i] , game ) ) return 1 ;
  temp.tid = index[i] ;
  temp.x = X ;
  temp.y = Y ;
  temp.operation = 4 ;
  temp.linkx  = -1 ;
  temp.linky = -1 ;
  build.push(temp);
  store.push_back(temp);
  temp_stick = temp_stick + matrix_tower_wave[index[i]][w] + number_mob_lives_wave[w] ;
  temp_money=temp_money + game->all_turrets[index[i]]->buy_price ;
  while ( ind < (int)store.size() ) {
    if ( store[ind].operation == 4 ) {
        int tmptid = store[ind].tid ;
        int tmpx =  store[ind].x ;
        int tmpy =  store[ind].y ;
        for ( int j = 0 ; j <(int) game->upgrade_graph[tmptid].size() ; j++ ) {
            int tid = game->upgrade_graph[tmptid][j] ;
            if ( search_tower ( tid ,store , game) ) {
               temp.tid = tid ;
               temp.x = X ;
               temp.y = Y ;
               temp.operation = 0 ;
               temp.linkx  = tmpx ;
               temp.linky  = tmpy ;
               store.push_back(temp);
               if ( game->all_turrets[tid]->type == 2 ) {
                   temp_stick = temp_stick - ( matrix_tower_wave[tid][w] + number_mob_lives_wave[w] ) ;
               }
            }
            else {
               if ( coordTower ( tid , game ) ) return 1 ;
               temp.tid = tid ;
               temp.x = X ;
               temp.y = Y ;
               temp.operation = 4 ;
               temp.linkx  = tmpx ;
               temp.linky  = tmpy ;
               build.push(temp);
               store.push_back(temp);
               temp_money=temp_money + game->all_turrets[tid]->buy_price ;
            }
       }  // end of for
    }  //end if operation 4
    ++ind ;
  }  // end  of while
 }  // end of for
 if ( temp_money > game->money ) return 1 ;
 // print_instruction (build , store, game) ;
 return 0 ;
}


int search_tower ( int tid , std::vector <_tower_> vv,TextGame *game ) {
   int flag = 0 ;
   for ( int a = 0 ; a < game->field->rows ; a++ )
    for ( int b = 0 ; b < game->field->cols;b++ )
        if ( mirror[a][b] == tid  ) {
           for ( int i = 0 ; i < (int)vv.size() ; ++i )
             if ( a == vv[i].x && b == vv[i].y ) {
              flag = 1 ;
              break ;
             }
           if ( flag == 1 ) {
             flag = 0 ;
             continue ;
           }
           X = a ;
           Y = b ;
           return 1 ;
        }

return 0 ;
}

int print_instruction (std::stack<_tower_> ss , std::vector <_tower_> vv, TextGame *game) {
 int num_inst , i , j;
  _tower_  tmp ;
  std::vector< FieldCellCoord > upgrades;

 num_inst = ss.size() ;
 num_inst = num_inst + countselltower ;

 OUT << num_inst << std::endl ;

 for ( i=0 ; i < countselltower ; ++i  ) {
   OUT << "5 " <<  selltowerstore[i][0] << " " ;
   OUT <<  selltowerstore[i][1] << " " << std::endl ;
 }
 countselltower = 0 ;

/*
// begin dump
  while (!ss.empty()) {
       tmp =  ss.top() ;

       std::cout << "tmp.tid = " << tmp.tid << std::endl ;
       std::cout << "tmp.x = " << tmp.x << std::endl ;
       std::cout << "tmp.y = " << tmp.y << std::endl ;
       std::cout << "tmp.operation = " << tmp.operation << std::endl ;
       std::cout << "tmp.linkx = " << tmp.linkx << std::endl ;
       std::cout << "tmp.linky = " << tmp.linky << std::endl << std::endl ;

       ss.pop() ;



    }

std::cout << "vv.size() =  " << vv.size() << std::endl ;

for (  i = 0 ; i < (int)vv.size() ; ++i ){
      std::cout << "vv[" << i << "].tid = " << vv[i].tid << std::endl ;
      std::cout << "vv[" << i << "].x = " << vv[i].x << std::endl ;
      std::cout << "vv[" << i << "].y = " << vv[i].y << std::endl ;
      std::cout << "vv[" << i << "].operation = " << vv[i].operation << std::endl ;
      std::cout << "vv[" << i << "].linkx = " << vv[i].linkx << std::endl ;
      std::cout << "vv[" << i << "].linky = " << vv[i].linky << std::endl << std::endl ;



}

 std::cout << "end dump" <<std::endl ;
*/
// end dump


 while (!ss.empty()) {
     tmp =  ss.top() ;
     OUT << tmp.operation << " " ;
     OUT << tmp.x << " " << tmp.y << " " << tmp.tid << " ";
     for (  i=0 ; i < (int) game->upgrade_graph[tmp.tid].size() ; ++i ) {
       for (  j=0 ; j <(int) vv.size(); j++ ) {
         if ( vv[j].tid == game->upgrade_graph[tmp.tid][i] &&
              vv[j].linkx == tmp.x && vv[j].linky == tmp.y) {
           OUT << vv[j].x << " " << vv[j].y << " " ;
           break ;
          }

       }

     }
     OUT << std::endl ;
     ss.pop() ;
 }

 // add tower and delete tower

 for (  j=0 ; j <(int) vv.size(); j++ ) {
    if ( vv[j].linkx != -1 &&  vv[j].linky != -1 && vv[j].operation == 0 ) {
       if( !game->sellTurret( vv[j].x ,  vv[j].y ) )
         printf ( "error sell x=%d,  y=%d\n" , vv[j].x , vv[j].y ) ;
       else
         game->money -= game->all_turrets[vv[j].tid]->sell_price ;
    }

    if ( vv[j].linkx == -1 &&  vv[j].linky == -1 && vv[j].operation == 4 ) {
       if( (i =  game->buyTurret( vv[j].tid  , vv[j].x ,  vv[j].y, upgrades )) < 0 ){
        printf ( "error bay turrent %d \n" , vv[j].tid ) ;
       }
       else tidindex[i] = vv[j].tid ;
    }

     if ( vv[j].linkx != -1 &&  vv[j].linky != -1 && vv[j].operation == 4 )
       game->money -= game->all_turrets[vv[j].tid]->buy_price ;

 }

  // std::cout << "game->money " << game->money <<  std::endl ;
return 0 ;
}

int build_decision_finish ( int k  , TextGame *game , int w ) {
 std::stack<_tower_> build ;
 std::vector<_tower_> store ;
 _tower_ temp  ;
 int i ,  ind = 0  ;

  // -1 = path , -2 = free , -3 block , zero or positive number tower ID
 fill_mirror ( game ) ;

 // print_mirror( game ) ;

  // temp_money = 0 ;

  for (i=0 ; i < k ; i++  ) {
  if ( coordTower ( save_index[i] , game ) ) return 1 ;
  temp.tid = save_index[i] ;
  temp.x = X ;
  temp.y = Y ;
  temp.operation = 4 ;
  temp.linkx  = -1 ;
  temp.linky = -1 ;
  build.push(temp);
  store.push_back(temp);
  // temp_money=temp_money + game->all_turrets[save_index[i]]->buy_price ;
  while ( ind < (int)store.size() ) {
    if ( store[ind].operation == 4 ) {
        int tmptid = store[ind].tid ;
        int tmpx =  store[ind].x ;
        int tmpy =  store[ind].y ;
        for ( int j = 0 ; j <(int) game->upgrade_graph[tmptid].size() ; j++ ) {
            int tid = game->upgrade_graph[tmptid][j] ;
            if ( search_tower ( tid ,store , game) ) {
               temp.tid = tid ;
               temp.x = X ;
               temp.y = Y ;
               temp.operation = 0 ;
               temp.linkx  = tmpx ;
               temp.linky  = tmpy ;
               store.push_back(temp);
            }
            else {
               if ( coordTower ( tid , game ) ) return 1 ;
               temp.tid = tid ;
               temp.x = X ;
               temp.y = Y ;
               temp.operation = 4 ;
               temp.linkx  = tmpx ;
               temp.linky  = tmpy ;
               build.push(temp);
               store.push_back(temp);
            //   temp_money=temp_money + game->all_turrets[tid]->buy_price ;
            }
       }  // end of for
    }  //end if operation 4
    ++ind ;
  }  // end  of while
 }  // end of for
 //std::cout << " temp_money " << temp_money << " game->money " << game->money << " w " << w <<std::endl ;
 print_instruction (build , store, game) ;

 return 0 ;
}


int print_mirror ( TextGame *game ) {
  int i , j  ;

   std::cout << std::endl ;
  // -1 = path , -2 = free , -3 block , zero or positive number tower ID
  for ( i = 0 ; i < game->field->rows ; i++ ) {
    std::cout << std::endl ;
    for ( j = 0 ; j < game->field->cols;j++ )
        std::cout << mirror[i][j]  << " "  ;
  }
  std::cout << std::endl ;
   return 0 ;

}

int selltower ( int x, int y , TextGame *game ) {
 if( !game->sellTurret( x ,  y ) ) {
         printf ( "error sell x=%d,  y=%d\n" , x , y ) ;
         return 1 ;
 }
 selltowerstore[countselltower][0] = x ;
 selltowerstore[countselltower][1] = y ;
 ++countselltower ;
 return 0 ;

}

int choice_sell ( int w , TextGame *game ) {
  int flag = 1 ;
  int wrk ;
  if ( 0 == game->totalTurretsBuild() ) return flag ;
  int limit = number_mob_lives_wave[w] / game->totalTurretsBuild() ;
  for ( int a = 0 ; a < game->field->rows ; a++ )
    for ( int b = 0 ; b < game->field->cols;b++ )
        if ( mirror[a][b] >= 0  ) {
            wrk = matrix_tower_wave[mirror[a][b]][w] + number_mob_lives_wave[w] ;
            if ( wrk <= limit     ) {
                if ( selltower(a,b,game) ) continue ;
                flag = 0 ;
            }
        }
return flag ;
}
